<?php 
require_once DRUPAL_ROOT . '/' . variable_get('password_inc', 'includes/password.inc');
//needed for user_hash_password

/**
 * Retrieves the current connected User.
 *
 * @return object()
 *  returns current connected or anonymous user
 *
 */

function connect() {
	global $user;
	$message=array(
		'uid'=>$user->uid,
		'username'=>$user->uid==0?t('Anonymous'):$user->name,
		'roles'=>$user->roles,
		);
		if(services_get_server_info('debug'))      
		watchdog('simpleconnect','connect: <pre>@msg</pre>',array('@msg' =>print_r($message,true)),WATCHDOG_DEBUG);
	return $message;
}

/**
 * Login user via REST SimpleConnect.
 *
 *
 * @param string $username
 *   Username to login.
 * @param string $password
 *   Password to login
 * @return object
 *   Returns the User object + token + session 	 
 * 
 */
function login($username,$password) {
	$name=check_plain($username);
	$pass=check_plain($password);
	if(services_get_server_info('debug')) 
	watchdog('simpleconnect','login: <pre>@name</pre>',array('@name' =>print_r($name,true)),WATCHDOG_DEBUG);

	
	if(user_is_logged_in())
		return services_error(t('This route is only accessible by anonymous users'), 403);

	//authenticate user		
	$uid = user_authenticate($name,$pass);
	//watchdog('simpleconnect','login UID: <pre>@msg</pre>',array('@msg' =>print_r($uid,true)),WATCHDOG_DEBUG);

	if (!$uid)return services_error(t('Wrong username or password'), 403);

	//load user		
	$user = user_load($uid);
	//login user
	$form_state = array();
	$form_state['uid'] = $user->uid;
	user_login_submit(array(), $form_state);


	$token=drupal_get_token('services');
	$sessionid = session_id();
	$session_name = session_name();

	$message=array(
		'uid'=>$user->uid,
		'username'=>$user->name,
		'roles'=>$user->roles,
		'token'=>$token,
		'session'=>$session_name.'_'.$sessionid,
//		'system'=>'DRUPAL7'
	);

	if(services_get_server_info('debug')) 
	 watchdog('simpleconnect','login: <pre>@msg</pre>',array('@msg' =>print_r($message,true)),WATCHDOG_DEBUG);
return $message;
}


/**
 * Logout the current user.
 *
 * @return object
 *   Returns the Anonymous User 	 
 * 
 */
function logout() {
global $user;
	if(services_get_server_info('debug')) 
		watchdog('simpleconnect','logout: <pre>@msg</pre>',array('@msg' =>print_r($user,true)),WATCHDOG_DEBUG);

	$tmp = NULL;
	drupal_save_session(TRUE);
	drupal_session_destroy_uid($user->uid);
	user_module_invoke('logout', $tmp, $user);
	$user = drupal_anonymous_user();
	$user->username=t("Anonymous");
	drupal_save_session(FALSE);
return $user;
}


 
/**
 * Registers and logs in new user.
 *
 * @param string $username
 *   Username to register.
 * @param string $password
 *   Password to register
 * @param string $email
 *   Email to register
 * @return object
 *   Returns the User object 	 
 * 
 */
function register($username,$password,$email){
	//sanitize input
	$name=check_plain($username);
	$pass=check_plain($password);
	$mail=check_plain($email);
	if(user_is_logged_in())
		return services_error(t('This route is only accessible by anonymous users'), 403);
		
	$message=array(
		'username'=>$name,
		'password'=>$pass,
		'email'=>$mail
		);
		//check email taken?
		$query = db_select('users', 'u')
			->fields('u', array('uid'))
			->condition('u.mail', $mail)
			->execute();
		$result = $query->fetch();
		// If the email is taken return not accepted error
		if ($result->uid)return services_error(t('Email already registered'), 406);

		//check if name taken?
		$query = db_select('users', 'u')
  			->fields('u', array('uid'))
  			->condition('u.name', $name)
  		->execute();
		$result = $query->fetch();
		// If the user name is taken return not accepted error.
		if ($result->uid)return services_error(t('Username already exists'), 406);

		// Build the user account object and then save it.
		$account = new stdClass();
		$account->name = $name;
		$account->mail = $mail;
		$account->init = $mail;
		$account->pass = user_hash_password($pass);
		$account->status = 1;
		user_save($account);

	if(services_get_server_info('debug')) 
		 watchdog('simpleconnect','register: <pre>@msg</pre>',array('@msg' =>print_r($account,true)),WATCHDOG_DEBUG);
return login($name,$pass);	
}