<?php 
/**
 * Provides the following REST actions
 * rest/simpleconnect/connect
 * rest/simpleconnect/logout
 * rest/simpleconnect/login
 * rest/simpleconnect/register 
 */



 /**
 * Implements hook_default_services_endpoint().
 */
function simpleconnect_default_services_endpoint() {
$endpoints = array();
$endpoint=new stdClass();	
$endpoint->disabled = FALSE; /* Edit this to true to make a default endpoint disabled initially */
$endpoint->api_version = 3;
$endpoint->name = 'simpleconnect';
$endpoint->server = 'rest_server';
$endpoint->path = 'rest';
$endpoint->authentication = array(
  'services' => 'services',
);
$endpoint->server_settings = array(
  'formatters' => array(
    'json' => TRUE,
    'bencode' => FALSE,
    'jsonp' => FALSE,
    'php' => FALSE,
    'xml' => FALSE,
    'yaml' => FALSE,
  ),
  'parsers' => array(
		'application/json' => TRUE,
    'multipart/form-data' => TRUE,
    'application/x-www-form-urlencoded' => FALSE,
    'application/x-yaml' => FALSE,
    'application/xml' => FALSE,
    'text/xml' => FALSE,
  )
);

$endpoint->resources = array(
  'simpleconnect' => array(
    'actions' => array(
      'connect' => array(
        'enabled' => '1',
      )
  	)
  )
);

$endpoint->debug = 1;
$endpoints[$endpoint->name] = $endpoint;
return $endpoints;
}

 /**
 * Implements hook_services_resouces().
 * 
 */
function simpleconnect_services_resources()
{
	$resources = array(
		'simpleconnect' => array(
			 'actions' => array(
			 		'connect' => array(
			 		'help' => 'Retrieve current user',
			 		'callback' => 'connect',
			 		'access arguments' => array('access content'),
			 		'file' => array('type' => 'inc', 'module' => 'simpleconnect', 'name' => 'simpleconnect.resource'),
					 ), //connect
					 'logout' => array(
						'help' => 'Log out current user',
						'callback' => 'logout',
						//'args' => array(),
						'access arguments' => array('access logout'),
						'file' => array('type' => 'inc', 'module' => 'simpleconnect', 'name' => 'simpleconnect.resource'),
						), //logout

						'login' => array(
							'help' => 'Log in user',
							'callback' => 'login',
							'args' => array(
													 array(
														 'name' => 'username',
														 'optional' => FALSE,
														 'source' => array('data'=>'username'),
														 'type' => 'string',
														 'description' => 'Username',
													 ),
													 array(
														 'name' => 'password',
														 'optional' => FALSE,
														 'source' => array('data'=>'password'),
														 'type' => 'string',
														 'description' => 'Password',
													 ),
										 		),
							'access arguments' => array('access login'),
							'file' => array('type' => 'inc', 'module' => 'simpleconnect', 'name' => 'simpleconnect.resource'),
							), //login

							'register' => array(
								'help' => 'Register a new user',
								'callback' => 'register',
								'args' => array(
														array(
															 'name' => 'username',
															 'optional' => FALSE,
															 'source' => array('data'=>'username'),
															 'type' => 'string',
															 'description' => 'Users Name',
														 ),
									 					array(
															 'name' => 'password',
															 'optional' => FALSE,
															 'source' => array('data'=>'password'),
															 'type' => 'string',
															 'description' => 'Users Password',
														 ),
														 array(
															'name' => 'email',
															'optional' => FALSE,
															'source' => array('data'=>'email'),
															'type' => 'string',
															'description' => 'Users Email',
														),
											 		),
								'access arguments' => array('access register'),
								'file' => array('type' => 'inc', 'module' => 'simpleconnect', 'name' => 'simpleconnect.resource'),
								), //register
	
			 	), //actions			 							
		),//simpleconnect	endpoint	
	);	//array	
	return $resources;
}
